#include "XBP.CH"
#include "APPEVENT.CH"
#include "GRA.CH"
#include "XBPDEV.CH"

PROCEDURE APPSYS
RETURN

PROCEDURE MAIN
LOCAL nEvent := 0, mp1 := 0, mp2 := 0, oXbp
LOCAL nRed := 0, nGreen := 0, nBlue := 0
LOCAL oDlg
LOCAL oSlideRed
LOCAL oSlideGreen
LOCAL oSlideBlue
LOCAL oStatic
LOCAL oVert
LOCAL bCallback

   oDlg       := XbpDialog():new(AppDesktop() ,, {0,0}, {800,600} )
   oDlg:title := "native Slider Demo"
   oDlg:Icon  := 1
   oDlg:tasklist  := .T.
   oDlg:MaxButton := .F.
   oDlg:clipChildren := .T.
   oDlg:DrawingArea:clipChildren := .T.
   oDlg:create()

   // show Color
   //
   oStatic := XbpStatic():new(oDlg:DrawingArea,,{100,400},{400,140})
   oStatic:create()


   // vertical
   //
   oVert := DXE_Slider():New(oDlg:DrawingArea,,{550,100},{40,400})
   oVert:Orientation := XBPPRN_ORIENT_PORTRAIT
   oVert:Range := {0,255}
   oVert:nBuddySpace := 40
   oVert:Create()
   //
   oVert:SetFrequency(20)
   oVert:oBudTopLeft    :SetCaption("Max")
   oVert:oBudBottomRight:SetCaption("Min")

   // Red
   //
   oSlideRed   := DXE_Slider():New(oDlg:DrawingArea,,{100,100},{400,40})
   oSlideRed:Orientation := XBPPRN_ORIENT_LANDSCAPE
   oSlideRed:Range := {0,255}
   oSlideRed:Create()
   //
   bCallback := {|mp1, mp2, oXbp| nRed   := mp1 , ;
                         ShowRGB( nRed, nGreen, nBlue ,oStatic) }
   oSlideRed:Track   := bCallback

   // Green
   //
   oSlideGreen := DXE_Slider():New(oDlg:DrawingArea,,{100,200},{400,40})
   oSlideGreen:Orientation := XBPPRN_ORIENT_LANDSCAPE
   oSlideGreen:Range := {0,255}
   oSlideGreen:nBuddySpace := 40
   oSlideGreen:Create()
   //
   oSlideGreen:oBudTopLeft    :SetCaption("Min")
   oSlideGreen:oBudBottomRight:SetCaption("Max")
   //
   bCallback := {|mp1, mp2, oXbp| nGreen := mp1 ,;
                         ShowRGB( nRed, nGreen, nBlue ,oStatic) }
   oSlideGreen:Track := bCallback

   // Blue
   //
   oSlideBlue  := DXE_Slider():New(oDlg:DrawingArea,,{100,300},{400,40})
   oSlideBlue:Orientation := XBPPRN_ORIENT_LANDSCAPE
   oSlideBlue:Range := {0,255}
   oSlideBlue:Create()
   bCallback := {|mp1, mp2, oXbp| nBlue  := mp1 , ;
                         ShowRGB( nRed, nGreen, nBlue ,oStatic) }
   oSlideBlue:Track  := bCallback


   CenterControl(oDlg)

   // mark Scope with Cursor Check when move
   //
   oSlideRed  :SetScope({050,185})
   oSlideGreen:SetScope({100,185})
   oSlideBlue :SetScope({201,255})

   // default Ticks ( Marker ) 1
   //
   oSlideRed  :SetFrequency(20)
   oSlideGreen:SetFrequency(10)
   oSlideBlue :SetFrequency(5)

   // Set-/Get-Data as usual
   //
   oSlideRed  :SetData(128)
   oSlideGreen:SetData(128)
   oSlideBlue :SetData(128)

   ShowRGB( nRed, nGreen, nBlue ,oStatic)
   SetAppFocus(oSlideRed)

   nEvent := xbeP_None
   DO WHILE nEvent != xbeP_Close
      nEvent := AppEvent( @mp1, @mp2, @oXbp )

      oXbp:HandleEvent( nEvent, mp1, mp2 )
   ENDDO

RETURN

PROCEDURE ShowRGB( nRed, nGreen, nBlue ,oStatic)
LOCAL oPS   := oStatic:lockPS() // presentation space
LOCAL aAttr := Array(GRA_AA_COUNT)        // area attributes
LOCAL aAStr := Array(GRA_AS_COUNT)        // string attributes
LOCAL nMax  := oPS:maxColorIndex()        // maximum colors
LOCAL aOldAttr
LOCAL aSize := oStatic:CurrentSize()

   // Set RGB color passed and draw box to
   // visualize it
   oPS:setColorIndex( nMax, {nRed,nGreen,nBlue} )

   aAttr[ GRA_AA_COLOR  ] := nMax
   aOldAttr := oPS:setAttrArea( aAttr )
   GraBox( oPS, {0,0}, aSize, GRA_FILL )
   oPS:setAttrArea( aOldAttr )

   aAStr[ GRA_AL_COLOR ] := XBPSYSCLR_WINDOWTEXT
   GraSetAttrString( oPS, aAStr )
   GraStringAt( oPS, {100, aSize[2]/2}, "R/G/B" + str(nRed)+str(nGreen)+str(nBlue) )

   oStatic:unlockPS()

RETURN

*
*
*